//+------------------------------------------------------------------+
//|                                           #MTF ReversaL_v1.2.mq4 |
//|                                                       ServerUang |
//|                                    http://www.indofx-trader.net/ |
//|                                                 modified by Goen |
//+------------------------------------------------------------------+
#property copyright "ServerUang"
#property link      "http://www.indofx-trader.net/"

#property indicator_chart_window
extern string Indicator_Name = "#MTF Reversal_v1";
extern int Sebelah = 1;
extern int Rev_Y = 10; 
extern int Rev_X = 0;
extern int WPR_period = 20;
extern double WPR_OverBought = -11;
extern double WPR_OverSold = -89;
extern int RSI_period = 4;
extern int RSI_OverBought = 89;
extern int RSI_OverSold = 11;
extern int CCI_period = 20;
extern double CCI_OverBought = 250;
extern double CCI_OverSold = -250;
extern int Stoch_period = 5;
extern int Stoch_OverBought = 70;
extern int Stoch_OverSold = 30;
extern color Turun = Red; 
extern color Naik = Lime;  

string Label_Teks="", Huruf="", Teks="";
color  Warna;
double x, y, n, TF, Nilai, Kolom, nilai_WPR, nilai_RSI, nilai_CCi;
int    Ukuran, Skor;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i = ObjectsTotal() - 1; i >= 0; i--)
     {
       string label = ObjectName(i);
       if(StringSubstr(label, 0, 3) != "Rev")
           continue;
       ObjectDelete(label);   
     }   //----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   Huruf="Tahoma Narrow"; Ukuran=7;
   if (MathMod(Sebelah,2)>0) {Teks="M1   M5  M15  M30  H1     H4";}
             else {Teks="H4     H1   M30  M15  M5  M1";}
   x=10+Rev_X;  y=10+Rev_Y;
   Tulis("Rev01", Sebelah, x, y, Teks, Ukuran, Huruf, White);
   x=x+122;
   Tulis("Rev02", Sebelah, x, y+9, "WPR", Ukuran, Huruf, White);
   Tulis("Rev03", Sebelah, x, y+21, "RSI", Ukuran, Huruf, White);
   Tulis("Rev04", Sebelah, x, y+33, "CCI", Ukuran, Huruf, White);
   Tulis("Rev05", Sebelah, x, y+45, "Sto", Ukuran, Huruf, White);
   
   //Lampu
   Kolom=20; n=1; Skor=0;
   while (n<=6)
      {
       switch (n)
          {
           case 1: TF=  1; break;
           case 2: TF=  5; break;
           case 3: TF= 15; break;
           case 4: TF= 30; break;
           case 5: TF= 60; break;
           case 6: TF=240; break;
          }
       
       Huruf="Arial Bold"; Ukuran=30; x=130+Rev_X; y=8+Rev_Y+4; Kolom=20;
       nilai_WPR=iWPR(Symbol(),TF,WPR_period,0);
       if (nilai_WPR>WPR_OverBought)
            { Teks=DoubleToStr(nilai_WPR,0); Warna=Turun; Skor=Skor-1;
              Tulis("Rev2"+DoubleToStr(n,0), Sebelah, x-(n*Kolom), y+6, "", 9, "Wingdings", Warna);
            }
       else if (nilai_WPR<WPR_OverSold)
            { Teks=DoubleToStr(nilai_WPR,0); Warna=Naik; Skor=Skor+1;
              Tulis("Rev2"+DoubleToStr(n,0), Sebelah, x-(n*Kolom), y+6, "", 9, "Wingdings", Warna);
            }
       else ObjectDelete("Rev2"+DoubleToStr(n,0));
            
            
       Nilai=iRSI(Symbol(),TF,RSI_period,0,0);
       if (Nilai>RSI_OverBought)
            { Teks=DoubleToStr(Nilai,0); Warna=Turun; Skor=Skor-1;
              Tulis("Rev3"+DoubleToStr(n,0), Sebelah, x-(n*Kolom), y+18, "", 9, "Wingdings", Warna);
            }
       else if (Nilai<RSI_OverSold)
            { Teks=DoubleToStr(Nilai,0); Warna=Naik; Skor=Skor+1;
              Tulis("Rev3"+DoubleToStr(n,0), Sebelah, x-(n*Kolom), y+18, "", 9, "Wingdings", Warna);
            }
       else ObjectDelete("Rev3"+DoubleToStr(n,0));
       
       
       Nilai=iCCI(Symbol(),TF,CCI_period,0,0);
       if (Nilai>CCI_OverBought)
            { Teks=DoubleToStr(Nilai,0); Warna=Turun; Skor=Skor-1;
              Tulis("Rev4"+DoubleToStr(n,0), Sebelah, x-(n*Kolom), y+30, "", 9, "Wingdings", Warna);
            }
       else if (Nilai<CCI_OverSold)
            { Teks=DoubleToStr(Nilai,0); Warna=Naik; Skor=Skor+1;
              Tulis("Rev4"+DoubleToStr(n,0), Sebelah, x-(n*Kolom), y+30, "", 9, "Wingdings", Warna);
            }
       else ObjectDelete("Rev4"+DoubleToStr(n,0));
       
       Nilai=iStochastic(Symbol(),TF,Stoch_period,3,3,0,MODE_MAIN,0,0);
       if (Nilai>Stoch_OverBought)
            { Teks=DoubleToStr(Nilai,0); Warna=Turun; Skor=Skor-1;
              Tulis("Rev5"+DoubleToStr(n,0), Sebelah, x-(n*Kolom), y+42, "", 9, "Wingdings", Warna);
            }
       else if (Nilai<Stoch_OverSold)
            { Teks=DoubleToStr(Nilai,0); Warna=Naik; Skor=Skor+1;
              Tulis("Rev5"+DoubleToStr(n,0), Sebelah, x-(n*Kolom), y+42, "", 9, "Wingdings", Warna);
            }
       else ObjectDelete("Rev5"+DoubleToStr(n,0));


       Huruf="Tahoma Narrow"; Ukuran=7;
       Tulis("Rev4"+DoubleToStr(n,0), Sebelah, x+4-(n*Kolom), y+57, DoubleToStr(Skor,0), Ukuran, Huruf, Gold);
       
       //if (Skor>1) 
       //   {
       //       Tulis("Rev5"+DoubleToStr(n,0), Sebelah, x-4-(n*Kolom), y+50, DoubleToStr(Skor,0), Ukuran, Huruf, Yellow);
       //   }
       //else Tulis("Rev5"+DoubleToStr(n,0), Sebelah, x-4-(n*Kolom), y+50, " ", Ukuran, Huruf, Black);
       
       Skor=0;
       n++;
     } //end while
     
     
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
// Prosedur Tulis
void Tulis(string LBL, double sebelah, int pos_x, int pos_y, string teks, int ukuran_huruf, string nama_huruf, color warna=CLR_NONE)
     {
       Label_Teks=LBL;
       ObjectCreate(LBL, OBJ_LABEL, 0, 0, 0);
       ObjectSetText(LBL,teks, ukuran_huruf, nama_huruf, warna);
       ObjectSet(LBL, OBJPROP_CORNER, sebelah);
       ObjectSet(LBL, OBJPROP_XDISTANCE, pos_x);
       ObjectSet(LBL, OBJPROP_YDISTANCE, pos_y);
     }